package rfctime

import "time"

type RFCTime interface {
	Time() time.Time
	Serialize() string

	UnmarshalJSON(bytes []byte) error
	MarshalJSON() ([]byte, error)

	MarshalBinary() ([]byte, error)
	UnmarshalBinary(data []byte) error

	GobEncode() ([]byte, error)
	GobDecode(data []byte) error

	MarshalText() ([]byte, error)
	UnmarshalText(data []byte) error

	After(u RFCTime) bool
	Before(u RFCTime) bool
	Equal(u RFCTime) bool
	IsZero() bool
	Date() (year int, month time.Month, day int)
	Year() int
	Month() time.Month
	Day() int
	Weekday() time.Weekday
	ISOWeek() (year, week int)
	Clock() (hour, min, sec int)
	Hour() int
	Minute() int
	Second() int
	Nanosecond() int
	YearDay() int
	Sub(u RFCTime) time.Duration
	Unix() int64
	UnixMilli() int64
	UnixMicro() int64
	UnixNano() int64
	Format(layout string) string
	GoString() string
	String() string
}
